// timeOutputDebugStringDlg.cpp : implementation file
//

#include "stdafx.h"
#include "timeOutputDebugString.h"
#include "timeOutputDebugStringDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Start with the initial number of item to output set to 4000

#define INITIAL_COUNT 4000

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeOutputDebugStringDlg dialog

CTimeOutputDebugStringDlg::CTimeOutputDebugStringDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTimeOutputDebugStringDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTimeOutputDebugStringDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTimeOutputDebugStringDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimeOutputDebugStringDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTimeOutputDebugStringDlg, CDialog)
	//{{AFX_MSG_MAP(CTimeOutputDebugStringDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeOutputDebugStringDlg message handlers

BOOL CTimeOutputDebugStringDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SetDlgItemInt(IDC_EDIT_COUNT, INITIAL_COUNT, FALSE);
	SetDlgItemText(IDC_STATIC_RESULTS, _T("Click Test to start the timing test."));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTimeOutputDebugStringDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTimeOutputDebugStringDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTimeOutputDebugStringDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTimeOutputDebugStringDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CTimeOutputDebugStringDlg::OnOK() 
{
	double	timeEmptyA, timeShortA, timeLongA;
	double	timeEmptyW, timeShortW, timeLongW;
	int		num;
	int		addLineEnding;

	num = GetDlgItemInt(IDC_EDIT_COUNT, NULL, FALSE);
	if (num <= 0)
	{
		// catch zero or -ve items

		num = INITIAL_COUNT;
		SetDlgItemInt(IDC_EDIT_COUNT, INITIAL_COUNT, FALSE);
	}

	addLineEnding = IsDlgButtonChecked(IDC_CHECK_LINE_ENDING);

	if (addLineEnding)
	{
		timeEmptyA = doTiming("", num);
		timeShortA = doTiming("Your elephant has been dancing on my lawn.\r\n", num);
		timeLongA = doTiming("Tiger, Lion, Leopard, Jaguar, Panther, Cougar, Cheetah, Fox, Dog, Cat, Zebra, Horse, Pony, Donkey, Mule, Giraffe, Monkey, Chimpanzee, Gorilla, Bonobo\r\n", num);

		timeEmptyW = doTiming(L"", num);
		timeShortW = doTiming(L"Your elephant has been dancing on my lawn.\r\n", num);
		timeLongW = doTiming(L"Tiger, Lion, Leopard, Jaguar, Panther, Cougar, Cheetah, Fox, Dog, Cat, Zebra, Horse, Pony, Donkey, Mule, Giraffe, Monkey, Chimpanzee, Gorilla, Bonobo\r\n", num);
	}
	else
	{
		timeEmptyA = doTiming("", num);
		timeShortA = doTiming("Your elephant has been dancing on my lawn.", num);
		timeLongA = doTiming("Tiger, Lion, Leopard, Jaguar, Panther, Cougar, Cheetah, Fox, Dog, Cat, Zebra, Horse, Pony, Donkey, Mule, Giraffe, Monkey, Chimpanzee, Gorilla, Bonobo", num);

		timeEmptyW = doTiming(L"", num);
		timeShortW = doTiming(L"Your elephant has been dancing on my lawn.", num);
		timeLongW = doTiming(L"Tiger, Lion, Leopard, Jaguar, Panther, Cougar, Cheetah, Fox, Dog, Cat, Zebra, Horse, Pony, Donkey, Mule, Giraffe, Monkey, Chimpanzee, Gorilla, Bonobo", num);
	}

	TCHAR	text[1000];
	CString	s;

	s.Format(_T("Time to output %d strings\r\n\r\n"), num);
	_stprintf(text, _T("%2.4lfs : OutputDebugStringA(\"\")\r\n"), timeEmptyA);
	s += text;
	_stprintf(text, _T("%2.4lfs : OutputDebugStringA(shortText)\r\n"), timeShortA);
	s += text;
	_stprintf(text, _T("%2.4lfs : OutputDebugStringA(longText)\r\n"), timeLongA);
	s += text;

	_stprintf(text, _T("%2.8lfs per call\r\n"), (double)(timeEmptyA + timeShortA + timeLongA) / (double)(num * 3));
	s += text;
	s += _T("\r\n");

	_stprintf(text, _T("%2.4lfs : OutputDebugStringW(\"\")\r\n"), timeEmptyW);
	s += text;
	_stprintf(text, _T("%2.4lfs : OutputDebugStringW(shortText)\r\n"), timeShortW);
	s += text;
	_stprintf(text, _T("%2.4lfs : OutputDebugStringW(longText)\r\n"), timeLongW);
	s += text;

	_stprintf(text, _T("%2.8lfs per call\r\n"), (double)(timeEmptyW + timeShortW + timeLongW) / (double)(num * 3));
	s += text;

	SetDlgItemText(IDC_STATIC_RESULTS, s);
}

double CTimeOutputDebugStringDlg::doTiming(char		*str,
										   DWORD	count)
{
	CString	s;

	s = _T("Timing OutputDebugStringA(");
	s += str;
	s += _T(")");
	SetDlgItemText(IDC_STATIC_RESULTS, s);
	Invalidate();
	UpdateWindow();

	DWORD			i;
	LARGE_INTEGER	start, end, freq;

	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&start);
	for(i = 0; i < count; i++)
	{
		OutputDebugStringA(str);
	}
	QueryPerformanceCounter(&end);

	double	res;

	res = (double)(end.QuadPart - start.QuadPart);
	res = res / freq.QuadPart;

	return res;
}

double CTimeOutputDebugStringDlg::doTiming(wchar_t	*str,
										   DWORD	count)
{
	CString	s;

	s = _T("Timing OutputDebugStringW(");
	s += str;
	s += _T(")");
	SetDlgItemText(IDC_STATIC_RESULTS, s);
	Invalidate();
	UpdateWindow();

	DWORD			i;
	LARGE_INTEGER	start, end, freq;

	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&start);
	for(i = 0; i < count; i++)
	{
		OutputDebugStringW(str);
	}
	QueryPerformanceCounter(&end);

	double	res;

	res = (double)(end.QuadPart - start.QuadPart);
	res = res / freq.QuadPart;

	return res;
}
